﻿////////////////////////////////////////////////////////////////////////
//                              MMMMMMMMMMMMMMMMM                     //
//                       MM     MMMMMMMMMMMMMMM M                    //
//                       MMM                MM M                    //
//          MMMM         MMM               MM M                    //
//        MMMMMMM      MMMM               MM M                    //
//           MMMM     MMM                MM M                    // 
//            MMMM  MMM                 MM M                    //
//             MMM MMM                 MM M                    //
//             MMMMM                  MM M                    //
//             MMMM                  MM M                    //  
//           MMMMMM                 MM M                    //
//          MMM  MMM               MM M MMMMMMMMMMMMMM     //
//        MMM    MMM              MMMMMMMMMMMMMMMMMMMM    //
//       MMM      MMMMMM                                 //
//     MMM        MMMMM                                 // 
//    MMM                                              //        
//   MMM                                              //       
//  MMM                                              //         
//  MM                                              //                 
//  MM                                             //                                         
//   MM     Holograph Emulator XZ Edit New r1.1   //                                       
///////////////////////////////////////////////////

using System;
using System.Threading;

using Holo.Managers;
using Holo.Socketservers;
using Microsoft.VisualBasic;
using Holo.Source.Managers;
using Ion.Storage;
using Holo.GameConnectionSystem;

namespace Holo
{
    /// <summary>
    /// The core of Holograph Emulator codename "Eucalypt", contains Main() void for booting server, plus monitoring thread and shutdown void.
    /// </summary>
    public class Eucalypt
    {
        private static Thread serverMonitor = new Thread(new ThreadStart(monitorServer));
        public delegate void commonDelegate();

        public static string serverVersion = "Holograph Emulator XZ r1.1" ;
        public static string dbHost;
        public static uint dbPort;
        public static string dbUsername;
        public static string dbPassword;
        public static string dbName;
        public static uint dbMaxConnections;
        public static int dbPool;
        public static DatabaseManager dbManager;
        public static Ion.Storage.Database database;

        public static int serverInviteID;
        public static int serverInviteSenderID;
        public static string serverInviteName;
        public static int serverInviteAccepted;
        public static int serverInviteAnswered;
        public static int serverInviteSendTo;
        public static bool remoteConnection;
        /// <summary>
        /// Starts up Holograph Emulator codename "Eucalypt".
        /// </summary>
        private static void Main()
        {
            Console.WindowHeight = Console.LargestWindowHeight / 2;
            Console.WindowWidth = Console.LargestWindowWidth / 2;
            Console.CursorVisible = false;
            Console.Title = "XZ Emulator r1.1";
            Out.WritePlain("Copyright (C) 2007-2010 By XZ & HoloSoft");                                                          
            Out.WritePlain("FRAMEWORK: 4.0 C# [r26,MySql]");                                                                  
            Out.WritePlain("Version: r1.1 edition");                                                                                          
            Out.WritePlain ("NOTE: This is still being developed");                                                         
            Out.WriteLine("Hope You Enjoy this any bugs report to the XZ Emulator thread");                                
            Out.WriteBlank();
            Out.WritePlain("Holograph History the legends who developed this ;]");
            Out.WritePlain("Nillus - The Habbo King Holograph God");
            Out.WritePlain("Dissi - Emu Coder");
            Out.WritePlain("awa500 (AWA) - Pets Base /Lido Queue/Lido Score Count");
            Out.WritePlain("martinmine - Hes Sexy Sockets");
            Out.WritePlain("cecer1 - Who can forget this guy ;]");
            Out.WritePlain("Vista4life - good old Maarten <3 ");
            Out.WritePlain("Kolesias123 - Coding Some Features Like Pet Packets And Pet String Walkthrough (Infoemu)");
            Out.WritePlain("There a others but i cant remeber");
            Out.WritePlain("This is edited version of Dissi\'s Edit.");
            Out.WritePlain("New features Should Be Found In The Thread ;P");
            Out.WriteBlank();
            Out.WritePlain("This is not another 'Holograph Emulator rename!!'");
            Out.WriteBlank();
            Out.WritePlain("The People who continued this is Zak/Xega/321olos ");                                               
                                                                                                                                                                                                        
            
            
            
            
                                                                                     
            Boot();
        }
        /// <summary>
        /// Boots the emulator.
        /// </summary>
        private static void Boot()
        {
            ThreadPool.SetMaxThreads(300,400);
            DateTime _START = DateTime.Now;
            //Out.WriteLine("Starting up Holograph Emulator for " + Environment.UserName + "...");
            string sqlConfigLocation = IO.workingDirectory + @"\config\mysql.ini";
            if (System.IO.File.Exists(sqlConfigLocation) == false)
            {
                Out.WriteError("Error Reason: Mysql Config Not found "); // This looks better ;] - Zak
                Shutdown();
                return;
            }

           //Out.WriteLine("mysql.ini found in " + sqlConfigLocation); Not Needed Lol. -Zak
            Out.WriteBlank();

            dbHost = IO.readINI("mysql", "host", sqlConfigLocation);
            dbPort = uint.Parse(IO.readINI("mysql", "port", sqlConfigLocation));
            dbUsername = IO.readINI("mysql", "username", sqlConfigLocation);
            dbPassword = IO.readINI("mysql", "password", sqlConfigLocation);
            dbName = IO.readINI("mysql", "database", sqlConfigLocation);
            dbMaxConnections = uint.Parse(IO.readINI("mysql", "clientamount", sqlConfigLocation));

            Out.WriteBlank();
            dbManager = new DatabaseManager(dbHost, dbPort, dbUsername, dbPassword, dbName, 1, 100);
            dbManager.SetClientAmount(dbMaxConnections);
            dbManager.StartMonitor();
            int gamePort;
            int gameMaxConnections;
            int musPort;
            int musMaxConnections;
            string musHost;

            try
            {
                gamePort = int.Parse(Config.getTableEntry("server_game_port"));
                gameMaxConnections = int.Parse(Config.getTableEntry("server_game_maxconnections"));
                musPort = int.Parse(Config.getTableEntry("server_mus_port"));
                musMaxConnections = int.Parse(Config.getTableEntry("server_mus_maxconnections"));
                musHost = Config.getTableEntry("server_mus_host");
            }
            catch
            {
                Out.WriteError("Error Reason: Connecting to Database Check MySql Config");
                Shutdown();
                return;
            }

            string langExt = Config.getTableEntry("lang");
            if (langExt == "")
            {
                Out.WriteError("Error Reason: Field Lang Was Not Found In Table System_config");
                Shutdown();
                return;
            }

            stringManager.Init(langExt, false);
            stringManager.initFilter(false);
            catalogueManager.Init(false);
            navigatorManager.Init();
            recyclerManager.Init(false);
            rankManager.Init(false);
            Config.Init(false);
            userManager.Init();
            eventManager.Init();
            gameSocketServer.SetupSocket(gamePort, gameMaxConnections); // New To Support the new sockets dont remove or you will get a error haha


            if (musSocketServer.Init(musPort, musHost) == false)
            {
                Shutdown();
                return;
            }


            resetDynamics();

            printDatabaseStats();
            Out.WriteBlank();

            DateTime _STOP = DateTime.Now;
            TimeSpan _TST = _STOP - _START;
            GC.Collect();
            Out.WriteLine("XZ Emulator status: Ready!");
            Out.WriteBlank();
            string date = DateAndTime.Now.ToString();
            //Out.WritePlain(date);

            Out.minimumImportance = Out.logFlags.MehAction; // All logs
            serverMonitor.Priority = ThreadPriority.Lowest;
            serverMonitor.Start();
        }
        /// <summary>
        /// Safely shutdowns Holograph Emulator, closing database and socket connections. Requires key press from user for final abort.
        /// </summary>
        public static void Shutdown()
        {
            Out.WriteBlank();
            if(serverMonitor.IsAlive)
                serverMonitor.Abort();
            Out.WriteLine("XZ - Emulator status: Shutdown!!");
            Console.ReadKey(true);
            Console.Beep(1400,1000);
            Environment.Exit(2);
        }
        /// <summary>
        /// Prints the usercount, guestroomcount and furniturecount in datebase to console.
        /// </summary>
        private static void printDatabaseStats()
        {
            int userCount;
            int roomCount;
            int itemCount;
            using (DatabaseClient dbClient = dbManager.GetClient())
            {
                userCount = dbClient.getInt("SELECT COUNT(*) FROM users");
                roomCount = dbClient.getInt("SELECT COUNT(*) FROM rooms");
                itemCount = dbClient.getInt("SELECT COUNT(*) FROM furniture");
            }
            //Out.WriteLine("Statistiche: " + userCount + " utenti, " + roomCount + " stanze e" + itemCount + " furni totali nell'hotel");
        }
        private static void resetDynamics()
        {
            int maxOnline = 0;
            using (DatabaseClient dbClient = dbManager.GetClient())
            {
                maxOnline = dbClient.getInt("SELECT onlinecount_peak FROM system");
                dbClient.runQuery("UPDATE system SET onlinecount = '0',onlinecount_peak = '" + maxOnline + "',connections_accepted = '0',activerooms = '0'");
                dbClient.runQuery("UPDATE users SET ticket_sso = NULL");
                dbClient.runQuery("UPDATE rooms SET visitors_now = '0'");
            }

            //Out.WriteLine("Connessioni resettate)");
            //Out.WriteLine("Counters resettate.");
            //Out.WriteLine("Tickets resettate.");
        }
        /// <summary>
        /// Threaded void. Ran on background thread at lowest priority, interval = 10000 ms. Updates console title and online users count, active rooms count, peak connections count and peak online users count in database.
        /// </summary>
        private static void monitorServer()
        {
            while(true)
            {
                int onlineCount = userManager.userCount;
                int peakOnlineCount = userManager.peakUserCount;
                int roomCount = roomManager.roomCount;
                int peakRoomCount = roomManager.peakRoomCount;
                //int databaseConnections =
                int starvationNumber = dbManager.getStarvationNumber();
                int acceptedConnections = gameSocketServer.acceptedConnections;
                long memUsage = GC.GetTotalMemory(false) / 1024;
                Console.Title = "XZ Emulator - [XZ] Group | RAM Usage: " + memUsage + "KB |SQL Connections: " + dbManager.databaseClients;
                using (DatabaseClient dbClient = dbManager.GetClient())
                {
                    dbClient.runQuery("UPDATE system SET onlinecount = '" + onlineCount + "',onlinecount_peak = '" + peakOnlineCount + "',activerooms = '" + roomCount + "',activerooms_peak = '" + peakRoomCount + "',connections_accepted = '" + acceptedConnections + "'");
                }
                Thread.Sleep(10000);
                //Out.WritePlain("Servermonitor loop");
            }
        }
    }
}